"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/vite/index.ts
var vite_exports = {};
__export(vite_exports, {
  vitePluginCopyHtml: () => vitePluginCopyHtml,
  vitePluginExport: () => vitePluginExport
});
module.exports = __toCommonJS(vite_exports);

// src/vite/vitePluginCopyHtml.ts
var import_promises = __toESM(require("fs/promises"));
var import_node_path = __toESM(require("path"));
var import_node_process = __toESM(require("process"));
async function vitePluginCopyHtml(template_url) {
  let content = await import_promises.default.readFile(
    import_node_path.default.resolve(import_node_process.default.cwd(), template_url),
    "utf-8"
  );
  return {
    name: "vite-plugin-copy-html",
    writeBundle(options, data) {
      const outDir = `${options.dir}/index.html`;
      const links = [];
      const scripts = [];
      for (const key in data) {
        if (key.endsWith(".css"))
          links.push(key);
        else if (key.endsWith(".js"))
          scripts.push(key);
      }
      if (links.length) {
        content = content.replace(
          /<\/head>/,
          () => `</head>
      ${links.map((link) => `<link rel="stylesheet" href="/${link}">`)}`
        );
      }
      if (scripts.length) {
        content = content.replace(
          /<\/body>/,
          () => `   ${scripts.map(
            (script) => `<script src="/${script}" type="module"></script>`
          )}
  </body>`
        );
      }
      import_promises.default.writeFile(import_node_path.default.resolve(outDir), content, "utf-8");
    }
  };
}

// src/vite/vitePluginExport.ts
function vitePluginExport(config) {
  return {
    name: "vite-plugin-export",
    transform(src, id) {
      if (id.endsWith(config)) {
        return {
          code: `export default ${JSON.stringify(src)}`,
          map: null
        };
      }
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  vitePluginCopyHtml,
  vitePluginExport
});
