"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// src/perf/createChunk.ts
var import_spark_md5 = __toESM(require("spark-md5"));
var hashMap = /* @__PURE__ */ new Map();
function createChunk(file, index, chunkSize) {
  return new Promise((resolve) => {
    const start = index * chunkSize;
    const end = start + chunkSize;
    const spark = new import_spark_md5.default.ArrayBuffer();
    const fileReader = new FileReader();
    fileReader.onload = (e) => {
      var _a;
      const fileBuffer = (_a = e.target) == null ? void 0 : _a.result;
      let hash;
      if (!hashMap.has(fileBuffer)) {
        spark.append(fileBuffer);
        hash = spark.end();
      } else {
        hash = hashMap.get(fileBuffer);
      }
      resolve({
        start,
        end,
        index,
        hash
      });
    };
    fileReader.readAsArrayBuffer(file.slice(start, end));
  });
}

// src/worker/fileSpliceWorker.ts
onmessage = async (e) => {
  const { file, chunkSize, startIndex, endIndex } = e.data;
  for (let i = startIndex; i < endIndex; i++)
    createChunk(file, i, chunkSize).then(postMessage);
};
